<?php

namespace Alive\Dm;

abstract class Short_Code {

    /**
     * Short code -> in wordpress it'll be [<?php short_code() ?>].
     **/
    abstract protected function short_code();
    /**
     * Load needed js and css.
     **/
    abstract protected function load_scripts();
    /**
     * Handle request for this short code.
     **/
    abstract public function handler($atts);

    /**
     * Register the shortcode/
     **/
    public function init() {
        $this->load_scripts();
        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));
        add_shortcode($this->short_code(), array($this, 'handler'));
    }

}
